<?php

namespace FM\Controller\IntegracoesLogin;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\IntegracoesLogin\GoogleService;
use FM\Traits\TResponse;

class GoogleController
{
    use TResponse;
    protected $GoogleService;

    public function __construct(GoogleService $GoogleService)
    {
        $this->GoogleService = $GoogleService;
    }

    public function getGoogleAuthUrl(Request $request)
    {
        try {
            $data = $this->GoogleService->getGoogleAuthUrl();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function callbackGoogle(Request $request)
    {
        try {
            $data = $this->GoogleService->handleGoogleCallback($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
}
