<?php

namespace FM\Service\IntegracoesLogin;

use Teknisa\Libs\Util\Environment;
use Doctrine\ORM\EntityManager;
require_once __DIR__ . '/../../../../../vendor/autoload.php';
use Google\Client as Google_Client;
use Google\Service\Oauth2 as Google_Service_Oauth2;
use FM\Factory\LoginFactory;
use FM\Service\LoginService;
use Zeedhi\Framework\DependencyInjection\InstanceManager;

class GoogleService
{
    protected $Environment;
    protected $newCode;
    protected $connection;
    protected $clientId;
    protected $clientSecret;
    protected $redirectUri;
    protected $LoginFactory;
    protected $LoginService; 
    protected $clientIdTeknisa;
    protected $clientSecretTeknisa;
    public function __construct(Environment $Environment, EntityManager $entityManager, LoginFactory $LoginFactory, LoginService $LoginService)
    {
        $this->Environment                  = $Environment;
        $this->connection                   = $entityManager->getConnection();
        $this->clientId                     = '308783089235-9evb9gm9vkibgl0mn9vg8frnvrhc3rc0.apps.googleusercontent.com';
        $this->clientSecret                 = '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';
        $this->redirectUri                  = 'https://fm-user-teste.teknisa.com/auth/login';
        // $this->redirectUri                  = 'http://localhost:8080/auth/login';
        $this->LoginFactory                 = $LoginFactory;
        $this->LoginService                 = $LoginService;
        $this->clientIdTeknisa              = "cd7e85178153by60953518945f9hakt19a50a4";
        $this->clientSecretTeknisa          = "lib5449996c21f780fe30badd6521931a5sac9";
    }
    
    function getGoogleAuthUrl() {
        $client = new Google_Client();
        $client->setClientId($this->clientId);
        $client->setClientSecret($this->clientSecret);
        $client->setRedirectUri($this->redirectUri);
        $client->addScope(['email', 'profile']);

        return $client->createAuthUrl();
    }

    function handleGoogleCallback($parametros) {
        
        $client = new Google_Client();
        $client->setClientId($this->clientId);
        $client->setClientSecret($this->clientSecret);
        $client->setRedirectUri($this->redirectUri);
    
        if (!isset($parametros['code'])) {
            throw new \Exception("Código de autenticação não recebido.");
        }
    
        // Trocar código pelo token de acesso
        $token = $client->fetchAccessTokenWithAuthCode($parametros['code']);
    
        if (isset($token['error'])) {
            throw new \Exception("Erro ao obter token: " . $token['error_description']);
        }

        $client->setAccessToken($token);
    
        // Obter informações do usuário
        $oauth = new Google_Service_Oauth2($client);
        $userInfo = $oauth->userinfo->get();
    
        $dataGoogle = [
            'email'     => $userInfo->email,
            'name'      => $userInfo->name,
            'google_id' => $userInfo->id,
            'picture'   => $userInfo->picture,
        ];
        $returnSessiontek = $this->validationsSignInWithGoogle($dataGoogle);

        return $returnSessiontek;
    }

    public function validationsSignInWithGoogle($dataGoogle)
    {
        $dados = $this->LoginFactory->getUser(array(
            "DSEMAILUSUARIOAPP" => $dataGoogle['email'],
        ));

        if (count($dados) === 0) {
            $this->signUpWithGoogle($dataGoogle);
        }
        return $this->signInWithGoogle($dataGoogle);
    }

    public function signUpWithGoogle($dataGoogle)
    {
        $this->connection->beginTransaction();

        try {
            $this->LoginService->signUp(array(
                "NAME"              => $dataGoogle['name'],
                "EMAIL"             => $dataGoogle['email'],
                "PASSWORD"          => $dataGoogle['google_id'],
            ));
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }

    public function signInWithGoogle($googleUserData)
    {
        $session = InstanceManager::getInstance()->getService('session');
        $session->start();

        $sessionId = $session->getId();

        // Verificar se o e-mail do Google já está cadastrado
        $dados = $this->LoginFactory->signIn([
            "DSEMAILUSUARIOAPP" => $googleUserData['email'],
            "DSSENHAUSUARIOAPP" => md5($googleUserData['google_id']),
        ]);

        if (!empty($dados)) {
            $token = InstanceManager::getInstance()->getService('oAuthImpl')->grantAccessToken($this->clientIdTeknisa, $this->clientSecretTeknisa, ['sessionId' => $sessionId]);

            // Salvar no MongoDB
            $mongoDb = InstanceManager::getInstance()->getService('mongoDB');
            $dataset = ['$set' => [
                'TOKEN' => $token,
                'DATA'  => $dados[0],
            ]];
            $filter = ['TOKEN' => $token];
            $mongoDb->update('LoginFMUserData', $filter, $dataset, true);

            return [
                "DSPRIMEIRONOME"    => $dados[0]['DSPRIMEIRONOME'],
                "DSULTIMONOME"      => $dados[0]['DSULTIMONOME'],
                "LOGIN_TOKEN"       => $token,
                "LOGIN_USER"        => \Teknisa\Libs\Util\Utilities::zeedhiEncrypt(json_encode($dados[0])),
            ];
        } else {
            throw new \Exception("Conta do Google não vinculada a um usuário. Faça o cadastro primeiro.");
        }
    }

}
