import Vue from 'vue';
import { Http } from '@zeedhi/core';
import App from './App.vue';
import router from './router';
import { vuetify } from './plugins';
import store from './store';
import './components';
import './registerServiceWorker';
import 'roboto-fontface/css/roboto/roboto-fontface.css';
import './styles/style.scss';

Vue.config.productionTip = false;

if (localStorage.getItem('LOGIN_TOKEN')) {
    Http.post('/startSession', {
        LOGIN_USER: localStorage.getItem('LOGIN_USER'),
    }).then(() => {
        newVue();
    }).catch((error: any) => {
        if (error.response && error.response.data && (error.response.data.errorCode === 100 || error.response.data.errorCode === 101)) {
            localStorage.clear();
            window.location.href = '/';
        } else {
            /* eslint-disable */
            alert('Ocorreu um erro inesperado. Entre em contato com o administrador do sistema.');
            /* eslint-enable */
        }
    });
} else if (router.currentRoute.fullPath === '/') {
    newVue();
} else {
    localStorage.clear();
    window.location.href = '/';
}

function newVue() {
    new Vue({
        router,
        vuetify,
        store,
        render: (h) => h(App),
    }).$mount('#app');
}
